package com.danitheskunk.skunkstuff;


import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.SlabBlock;
import net.minecraft.world.level.material.Material;
import org.quiltmc.qsl.block.extensions.api.QuiltBlockSettings;

public class BlockBuilder extends QuiltBlockSettings {
	public String name;
	public CreativeModeTab creativeModeTab = CreativeModeTab.TAB_MISC;
	public BlockType blockType;
	public Block block;
	public BlockBuilder() {
		super(QuiltBlockSettings.of(Material.WOOD));
		strength(2);
		opaque(false);
		blockType = BlockType.Full;
	}

	public BlockBuilder name(String name) {
		this.name = name;
		return this;
	}

	public BlockBuilder creativeModeTab(CreativeModeTab creativeModeTab) {
		this.creativeModeTab = creativeModeTab;
		return this;
	}

	public BlockBuilder slab() {
		blockType = BlockType.Slab;
		return this;
	}

	public Block build() {
		block = switch(blockType) {
			case Full -> new Block(this);
			case Slab -> new SlabBlock(this);
		};
		Blocks.addToDeffered(this);
		return block;
	}
	private enum BlockType {
		Full, Slab
	}
}
