package com.danitheskunk.skunkstuff;

import net.minecraft.core.Registry;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.BlockItem;
import net.minecraft.world.item.CreativeModeTab;
import org.quiltmc.qsl.item.setting.api.QuiltItemSettings;

import java.util.ArrayList;
import java.util.List;

public class Blocks {
	private static final List<BlockBuilder> deferred = new ArrayList<>();
	private static final String namespace = "skunkstuff";

	public static BlockBuilder register() {
		return new BlockBuilder();
	}

	public static void addToDeffered(BlockBuilder builder) {
		deferred.add(builder);
	}

	public static void registerAll() {
		for(var block : deferred) {
			Registry.register(
				Registry.BLOCK,
				new ResourceLocation(namespace, block.name),
				block.block
			);
			Registry.register(
				Registry.ITEM,
				new ResourceLocation(namespace, block.name),
				new BlockItem(
					block.block,
					new QuiltItemSettings().group(block.creativeModeTab)
				)
			);
		}
	}
}
